Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/sutil.f90	(revision 2696)
@@ -0,0 +1,587 @@
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppDecomp( JVS, IER )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!        Sparse LU factorization
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER  :: IER
+      KPP_REAL :: JVS(LU_NONZERO), W(NVAR), a
+      INTEGER  :: k, kk, j, jj
+
+      a = 0. ! mz_rs_20050606
+      IER = 0
+      DO k=1,NVAR
+        ! mz_rs_20050606: don't check if real value == 0
+        ! IF ( JVS( LU_DIAG(k) ) .EQ. 0. ) THEN
+        IF ( ABS(JVS(LU_DIAG(k))) < TINY(a) ) THEN
+            IER = k
+            RETURN
+        END IF
+        DO kk = LU_CROW(k), LU_CROW(k+1)-1
+              W( LU_ICOL(kk) ) = JVS(kk)
+        END DO
+        DO kk = LU_CROW(k), LU_DIAG(k)-1
+            j = LU_ICOL(kk)
+            a = -W(j) / JVS( LU_DIAG(j) )
+            W(j) = -a
+            DO jj = LU_DIAG(j)+1, LU_CROW(j+1)-1
+               W( LU_ICOL(jj) ) = W( LU_ICOL(jj) ) + a*JVS(jj)
+            END DO
+         END DO
+         DO kk = LU_CROW(k), LU_CROW(k+1)-1
+            JVS(kk) = W( LU_ICOL(kk) )
+         END DO
+      END DO
+      
+END SUBROUTINE KppDecomp
+
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppDecompCmplx( JVS, IER )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!        Sparse LU factorization, complex
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER        :: IER
+      DOUBLE COMPLEX :: JVS(LU_NONZERO), W(NVAR), a
+      KPP_REAL  :: b = 0.0
+      INTEGER        :: k, kk, j, jj
+
+      IER = 0
+      DO k=1,NVAR
+        IF ( ABS(JVS(LU_DIAG(k))) < TINY(b) ) THEN
+            IER = k
+            RETURN
+        END IF
+        DO kk = LU_CROW(k), LU_CROW(k+1)-1
+              W( LU_ICOL(kk) ) = JVS(kk)
+        END DO
+        DO kk = LU_CROW(k), LU_DIAG(k)-1
+            j = LU_ICOL(kk)
+            a = -W(j) / JVS( LU_DIAG(j) )
+            W(j) = -a
+            DO jj = LU_DIAG(j)+1, LU_CROW(j+1)-1
+               W( LU_ICOL(jj) ) = W( LU_ICOL(jj) ) + a*JVS(jj)
+            END DO
+         END DO
+         DO kk = LU_CROW(k), LU_CROW(k+1)-1
+            JVS(kk) = W( LU_ICOL(kk) )
+         END DO
+      END DO
+      
+END SUBROUTINE KppDecompCmplx
+
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppDecompCmplxR( JVSR, JVSI, IER )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!    Sparse LU factorization, complex
+!   (Real and Imaginary parts are used instead of complex data type)     
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER       :: IER
+      KPP_REAL :: JVSR(LU_NONZERO), JVSI(LU_NONZERO) 
+      KPP_REAL :: WR(NVAR), WI(NVAR), ar, ai, den
+      INTEGER       :: k, kk, j, jj
+
+      IER = 0
+      ar  = 0.0
+      DO k=1,NVAR
+        IF (  ( ABS(JVSR(LU_DIAG(k))) < TINY(ar) ) .AND. &
+              ( ABS(JVSI(LU_DIAG(k))) < TINY(ar) ) )  THEN
+            IER = k
+            RETURN
+        END IF
+        DO kk = LU_CROW(k), LU_CROW(k+1)-1
+              WR( LU_ICOL(kk) ) = JVSR(kk)
+              WI( LU_ICOL(kk) ) = JVSI(kk)
+        END DO
+        DO kk = LU_CROW(k), LU_DIAG(k)-1
+            j = LU_ICOL(kk)
+            den = JVSR(LU_DIAG(j))**2 + JVSI(LU_DIAG(j))**2
+            ar = -(WR(j)*JVSR(LU_DIAG(j)) + WI(j)*JVSI(LU_DIAG(j)))/den
+            ai = -(WI(j)*JVSR(LU_DIAG(j)) - WR(j)*JVSI(LU_DIAG(j)))/den
+            WR(j) = -ar
+            WI(j) = -ai
+            DO jj = LU_DIAG(j)+1, LU_CROW(j+1)-1
+               WR( LU_ICOL(jj) ) = WR( LU_ICOL(jj) ) + ar*JVSR(jj) - ai*JVSI(jj)
+               WI( LU_ICOL(jj) ) = WI( LU_ICOL(jj) ) + ar*JVSI(jj) + ai*JVSR(jj)
+            END DO
+         END DO
+         DO kk = LU_CROW(k), LU_CROW(k+1)-1
+            JVSR(kk) = WR( LU_ICOL(kk) )
+            JVSI(kk) = WI( LU_ICOL(kk) )
+         END DO
+      END DO
+
+END SUBROUTINE KppDecompCmplxR
+
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppSolveIndirect( JVS, X )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!        Sparse solve subroutine using indirect addressing
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER  :: i, j
+      KPP_REAL :: JVS(LU_NONZERO), X(NVAR), sum
+
+      DO i=1,NVAR
+         DO j = LU_CROW(i), LU_DIAG(i)-1 
+             X(i) = X(i) - JVS(j)*X(LU_ICOL(j));
+         END DO  
+      END DO
+
+      DO i=NVAR,1,-1
+        sum = X(i);
+        DO j = LU_DIAG(i)+1, LU_CROW(i+1)-1
+          sum = sum - JVS(j)*X(LU_ICOL(j));
+        END DO
+        X(i) = sum/JVS(LU_DIAG(i));
+      END DO
+      
+END SUBROUTINE KppSolveIndirect
+
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppSolveTRIndirect( JVS, X )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!        Complex sparse solve transpose subroutine using indirect addressing
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER       :: i, j
+      KPP_REAL :: JVS(LU_NONZERO), X(NVAR)
+
+      DO i=1,NVAR
+        X(i) = X(i)/JVS(LU_DIAG(i))
+	! subtract all nonzero elements in row i of JVS from X
+        DO j=LU_DIAG(i)+1,LU_CROW(i+1)-1
+	  X(LU_ICOL(j)) = X(LU_ICOL(j))-JVS(j)*X(i)
+	END DO
+      END DO
+
+      DO i=NVAR, 1, -1
+	! subtract all nonzero elements in row i of JVS from X
+        DO j=LU_CROW(i),LU_DIAG(i)-1
+	  X(LU_ICOL(j)) = X(LU_ICOL(j))-JVS(j)*X(i)
+	END DO
+      END DO
+      
+END SUBROUTINE KppSolveTRIndirect
+
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppSolveCmplx( JVS, X )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!        Complex sparse solve subroutine using indirect addressing
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER        :: i, j
+      DOUBLE COMPLEX :: JVS(LU_NONZERO), X(NVAR), sum
+
+      DO i=1,NVAR
+         DO j = LU_CROW(i), LU_DIAG(i)-1 
+             X(i) = X(i) - JVS(j)*X(LU_ICOL(j));
+         END DO  
+      END DO
+
+      DO i=NVAR,1,-1
+        sum = X(i);
+        DO j = LU_DIAG(i)+1, LU_CROW(i+1)-1
+          sum = sum - JVS(j)*X(LU_ICOL(j));
+        END DO
+        X(i) = sum/JVS(LU_DIAG(i));
+      END DO
+      
+END SUBROUTINE KppSolveCmplx
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppSolveCmplxR( JVSR, JVSI, XR, XI )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!   Complex sparse solve subroutine using indirect addressing
+!   (Real and Imaginary parts are used instead of complex data type)     
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER       ::  i, j
+      KPP_REAL ::  JVSR(LU_NONZERO), JVSI(LU_NONZERO), XR(NVAR), XI(NVAR), sumr, sumi, den
+
+      DO i=1,NVAR
+         DO j = LU_CROW(i), LU_DIAG(i)-1 
+             XR(i) = XR(i) - (JVSR(j)*XR(LU_ICOL(j)) - JVSI(j)*XI(LU_ICOL(j)))
+             XI(i) = XI(i) - (JVSR(j)*XI(LU_ICOL(j)) + JVSI(j)*XR(LU_ICOL(j)))
+         END DO  
+      END DO
+
+      DO i=NVAR,1,-1
+        sumr = XR(i); sumi = XI(i)
+        DO j = LU_DIAG(i)+1, LU_CROW(i+1)-1
+            sumr = sumr - (JVSR(j)*XR(LU_ICOL(j)) - JVSI(j)*XI(LU_ICOL(j)))
+            sumi = sumi - (JVSR(j)*XI(LU_ICOL(j)) + JVSI(j)*XR(LU_ICOL(j)))
+        END DO
+        den   = JVSR(LU_DIAG(i))**2 + JVSI(LU_DIAG(i))**2
+        XR(i) = (sumr*JVSR(LU_DIAG(i)) + sumi*JVSI(LU_DIAG(i)))/den
+        XI(i) = (sumi*JVSR(LU_DIAG(i)) - sumr*JVSI(LU_DIAG(i)))/den
+      END DO
+      
+END SUBROUTINE KppSolveCmplxR
+
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppSolveTRCmplx( JVS, X )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!        Complex sparse solve transpose subroutine using indirect addressing
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER        :: i, j
+      DOUBLE COMPLEX :: JVS(LU_NONZERO), X(NVAR)
+
+      DO i=1,NVAR
+        X(i) = X(i)/JVS(LU_DIAG(i))
+	! subtract all nonzero elements in row i of JVS from X
+        DO j=LU_DIAG(i)+1,LU_CROW(i+1)-1
+	  X(LU_ICOL(j)) = X(LU_ICOL(j))-JVS(j)*X(i)
+	END DO
+      END DO
+
+      DO i=NVAR, 1, -1
+	! subtract all nonzero elements in row i of JVS from X
+        DO j=LU_CROW(i),LU_DIAG(i)-1
+	  X(LU_ICOL(j)) = X(LU_ICOL(j))-JVS(j)*X(i)
+	END DO
+      END DO
+      
+END SUBROUTINE KppSolveTRCmplx
+
+
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+SUBROUTINE KppSolveTRCmplxR( JVSR, JVSI, XR, XI )
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!   Complex sparse solve transpose subroutine using indirect addressing
+!   (Real and Imaginary parts are used instead of complex data type)     
+! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+  USE KPP_ROOT_Parameters
+  USE KPP_ROOT_JacobianSP
+
+      INTEGER       ::  i, j
+      KPP_REAL ::  JVSR(LU_NONZERO), JVSI(LU_NONZERO), XR(NVAR), XI(NVAR), den
+
+      DO i=1,NVAR
+        den   = JVSR(LU_DIAG(i))**2 + JVSI(LU_DIAG(i))**2
+        XR(i) = (XR(i)*JVSR(LU_DIAG(i)) + XI(i)*JVSI(LU_DIAG(i)))/den
+        XI(i) = (XI(i)*JVSR(LU_DIAG(i)) - XR(i)*JVSI(LU_DIAG(i)))/den
+	! subtract all nonzero elements in row i of JVS from X
+        DO j=LU_DIAG(i)+1,LU_CROW(i+1)-1
+	  XR(LU_ICOL(j)) = XR(LU_ICOL(j))-(JVSR(j)*XR(i) - JVSI(j)*XI(i))
+	  XI(LU_ICOL(j)) = XI(LU_ICOL(j))-(JVSI(j)*XR(i) + JVSR(j)*XI(i))
+	END DO
+      END DO
+
+      DO i=NVAR, 1, -1
+	! subtract all nonzero elements in row i of JVS from X
+        DO j=LU_CROW(i),LU_DIAG(i)-1
+	  XR(LU_ICOL(j)) = XR(LU_ICOL(j))-(JVSR(j)*XR(i) - JVSI(j)*XI(i))
+	  XI(LU_ICOL(j)) = XI(LU_ICOL(j))-(JVSI(j)*XR(i) + JVSR(j)*XI(i))
+	END DO
+      END DO
+      
+END SUBROUTINE KppSolveTRCmplxR
+
+
+!
+! Next few commented subroutines perform sparse big linear algebra
+!
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!SUBROUTINE KppDecompBig( JVS, IP, IER )
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!!        Sparse LU factorization
+!!        for the Runge Kutta (3n)x(3n) linear system
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!
+!  USE KPP_ROOT_Parameters
+!  USE KPP_ROOT_JacobianSP
+!
+!      INTEGER  :: IP3(3), IER, IP(3,NVAR)
+!      KPP_REAL :: JVS(3,3,LU_NONZERO), W(3,3,NVAR), a(3,3), E(3,3)
+!      INTEGER  :: k, kk, j, jj
+!
+!      a = 0.0d0
+!      IER = 0
+!      DO k=1,NVAR
+!        DO kk = LU_CROW(k), LU_CROW(k+1)-1
+!              W( 1:3,1:3,LU_ICOL(kk) ) = JVS(1:3,1:3,kk)
+!        END DO
+!        DO kk = LU_CROW(k), LU_DIAG(k)-1
+!            j = LU_ICOL(kk)
+!            E(1:3,1:3) = JVS( 1:3,1:3,LU_DIAG(j) )
+!            ! CALL DGETRF(3,3,E,3,IP3,IER) 
+!            CALL FAC3(E,IP3,IER)
+!            IF ( IER /= 0 )  RETURN
+!            ! a = W(j) / JVS( LU_DIAG(j) )
+!            a(1:3,1:3) = W( 1:3,1:3,j )
+!            ! CALL DGETRS ('N',3,3,E,3,IP3,a,3,IER) 
+!            CALL SOL3('N',E,IP3,a(1,1))
+!            CALL SOL3('N',E,IP3,a(1,2))
+!            CALL SOL3('N',E,IP3,a(1,3))
+!            W(1:3,1:3,j) = a(1:3,1:3)
+!            DO jj = LU_DIAG(j)+1, LU_CROW(j+1)-1
+!               W( 1:3,1:3,LU_ICOL(jj) ) = W( 1:3,1:3,LU_ICOL(jj) ) &
+!                        - MATMUL( a(1:3,1:3) , JVS(1:3,1:3,jj) )
+!            END DO
+!         END DO
+!         DO kk = LU_CROW(k), LU_CROW(k+1)-1
+!            JVS(1:3,1:3,kk) = W( 1:3,1:3,LU_ICOL(kk) )
+!         END DO
+!      END DO
+!
+!      DO k=1,NVAR
+!         ! CALL WGEFA(JVS(1,1,LU_DIAG(k)),3,3,IP(1,k),IER)
+!         ! CALL DGETRF(3,3,JVS(1,1,LU_DIAG(k)),3,IP(1,k),IER)
+!         CALL FAC3(JVS(1,1,LU_DIAG(k)),IP(1,k),IER)
+!         IF ( IER /= 0 )  RETURN
+!      END DO 
+!      
+!END SUBROUTINE KppDecompBig
+!
+!
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!SUBROUTINE KppSolveBig( JVS, IP, X )
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!!        Sparse solve subroutine using indirect addressing
+!!        for the Runge Kutta (3n)x(3n) linear system
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!
+!  USE KPP_ROOT_Parameters
+!  USE KPP_ROOT_JacobianSP
+!
+!      INTEGER  :: i, j, k, m, IP3(3), IP(3,NVAR), IER
+!      KPP_REAL :: JVS(3,3,LU_NONZERO), X(3,NVAR), sum(3)
+!
+!      DO i=1,NVAR
+!        DO j = LU_CROW(i), LU_DIAG(i)-1 
+!          !X(1:3,i) = X(1:3,i) - MATMUL(JVS(1:3,1:3,j),X(1:3,LU_ICOL(j)));
+!          DO k=1,3
+!            DO m=1,3
+!	       X(k,i) = X(k,i) - JVS(k,m,j)*X(m,LU_ICOL(j))
+!            END DO
+!          END DO
+!        END DO  
+!      END DO
+!
+!      DO i=NVAR,1,-1
+!        sum(1:3) = X(1:3,i);
+!        DO j = LU_DIAG(i)+1, LU_CROW(i+1)-1
+!          !sum(1:3) = sum(1:3) - MATMUL(JVS(1:3,1:3,j),X(1:3,LU_ICOL(j)));
+!          DO k=1,3
+!            DO m=1,3
+!	       sum(k) = sum(k) - JVS(k,m,j)*X(m,LU_ICOL(j))
+!            END DO
+!          END DO
+!        END DO
+!        ! X(i) = sum/JVS(LU_DIAG(i));
+!        ! CALL DGETRS ('N',3,1,JVS(1:3,1:3,LU_DIAG(i)),3,IP(1,i),sum,3,0) 
+!        ! CALL WGESL('N',JVS(1,1,LU_DIAG(i)),3,3,IP(1,i),sum)
+!        CALL SOL3('N',JVS(1,1,LU_DIAG(i)),IP(1,i),sum)
+!        X(1:3,i) = sum(1:3)
+!      END DO
+!      
+!END SUBROUTINE KppSolveBig
+!
+!
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!SUBROUTINE KppSolveBigTR( JVS, IP, X )
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!!        Big sparse transpose solve using indirect addressing
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!
+!  USE KPP_ROOT_Parameters
+!  USE KPP_ROOT_JacobianSP
+!
+!      INTEGER       :: i, j, k, m, IP(3,NVAR)
+!      KPP_REAL :: JVS(3,3,LU_NONZERO), X(3,NVAR)
+!
+!      DO i=1,NVAR
+!        ! X(i) = X(i)/JVS(LU_DIAG(i))
+!        CALL SOL3('T',JVS(1,1,LU_DIAG(i)),IP(1,i),X(1,i))
+!        DO j=LU_DIAG(i)+1,LU_CROW(i+1)-1
+!	  !X(1:3,LU_ICOL(j)) = X(1:3,LU_ICOL(j)) &
+!          !    - MATMUL( TRANSPOSE(JVS(1:3,1:3,j)), X(1:3,i) )
+!          DO k=1,3
+!            DO m=1,3
+!	       X(k,LU_ICOL(j)) = X(k,LU_ICOL(j)) - JVS(m,k,j)*X(m,i)
+!            END DO
+!          END DO
+!	END DO
+!      END DO
+!
+!      DO i=NVAR, 1, -1
+!        DO j=LU_CROW(i),LU_DIAG(i)-1
+!	  !X(1:3,LU_ICOL(j)) = X(1:3,LU_ICOL(j)) &
+!          !   - MATMUL( TRANSPOSE(JVS(1:3,1:3,j)), X(1:3,i) )
+!          DO k=1,3
+!            DO m=1,3
+!	       X(k,LU_ICOL(j)) = X(k,LU_ICOL(j)) - JVS(m,k,j)*X(m,i)
+!            END DO
+!          END DO
+!	END DO
+!      END DO
+!      
+!END SUBROUTINE KppSolveBigTR
+!
+!
+!
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!SUBROUTINE FAC3(A,IPVT,INFO)
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!!     FAC3 FACTORS THE MATRIX A (3,3) BY
+!!           GAUSS ELIMINATION WITH PARTIAL PIVOTING
+!!     LINPACK - LIKE 
+!!
+!!     Remove comments to perform pivoting
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!!
+!      KPP_REAL :: A(3,3)
+!      INTEGER       :: IPVT(3),INFO
+!!      INTEGER       :: L
+!!      KPP_REAL :: t, dmax, da, TMP(3)
+!      KPP_REAL, PARAMETER :: ZERO = 0.0, ONE = 1.0
+!
+!      info = 0
+!!      t = TINY(da)
+!!      
+!!      da = ABS(A(1,1)); L = 1
+!!      IF ( ABS(A(2,1))>da ) THEN
+!!        da = ABS(A(2,1)); L = 2
+!!        IF ( ABS(A(3,1))>da ) THEN
+!!          L = 3
+!!        END IF  
+!!      END IF  
+!!      IPVT(1)  = L
+!!      IF (L /=1 ) THEN
+!!         TMP(1:3) = A(L,1:3)
+!!         A(L,1:3) = A(1,1:3)
+!!         A(1,1:3) = TMP(1:3)
+!!      END IF
+!!      IF (ABS(A(1,1)) < t) THEN
+!!         info = 1
+!!         return
+!!      END IF   
+!!
+!      A(2,1) = A(2,1)/A(1,1)
+!      A(2,2) = A(2,2) - A(2,1)*A(1,2)
+!      A(2,3) = A(2,3) - A(2,1)*A(1,3)
+!      A(3,1) = A(3,1)/A(1,1)
+!      A(3,2) = A(3,2) - A(3,1)*A(1,2)
+!      A(3,3) = A(3,3) - A(3,1)*A(1,3)
+!      
+!!      IPVT(2)  = 2
+!!      IF (ABS(A(3,2))>ABS(A(2,2))) THEN
+!!         IPVT(2)  = 3
+!!         TMP(2:3) = A(3,2:3)
+!!         A(3,2:3) = A(2,2:3)
+!!         A(2,2:3) = TMP(2:3)
+!!      END IF
+!!      IF (ABS(A(2,2)) < t) THEN
+!!         info = 1
+!!         return
+!!      END IF   
+!!      
+!      A(3,2)   = A(3,2)/A(2,2)
+!      A(3,3)   = A(3,3) - A(3,2)*A(2,3)
+!      IPVT(3)  = 3
+!      
+!END SUBROUTINE FAC3
+!
+!
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!SUBROUTINE SOL3(Trans,A,IPVT,b)
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!!     SOL3 solves the system 3x3
+!!     A * x = b  or  trans(a) * x = b
+!!     using the factors computed by WGEFA.
+!!
+!!     Trans      = 'N'   to solve  A*x = b ,
+!!                = 'T'   to solve  transpose(A)*x = b
+!!     LINPACK - LIKE 
+!!
+!!     Remove comments to use pivoting
+!! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!
+!      CHARACTER     :: Trans
+!      KPP_REAL :: a(3,3),b(3)
+!      INTEGER       :: IPVT(3)
+!!      INTEGER       :: L
+!!      KPP_REAL :: TMP
+!      
+!      SELECT CASE (Trans)
+!
+!      CASE ('n','N')  !  Solve  A * x = b
+!
+!!     Solve  L*y = b
+!!         L = IPVT(1)
+!!         IF (L /= 1) THEN
+!!            TMP = B(1); B(1) = B(L); B(L) = TMP
+!!         END IF
+!         b(2) = b(2)-A(2,1)*b(1)
+!         b(3) = b(3)-A(3,1)*b(1)
+!         
+!!         L = IPVT(2)
+!!         IF (L /= 2) THEN
+!!            TMP = B(2); B(2) = B(L); B(L) = TMP
+!!         END IF
+!         b(3) = b(3)-A(3,2)*b(2)
+!
+!!     Solve  U*x = y
+!         b(3) = b(3)/A(3,3)
+!         b(2) = (b(2)-A(2,3)*b(3))/A(2,2)
+!         b(1) = (b(1)-A(1,3)*b(3)-A(1,2)*b(2))/A(1,1)
+!      
+!      
+!      CASE ('t','T')  !  Solve transpose(A) * x = b
+!
+!!      Solve transpose(U)*y = b
+!         b(1) = b(1)/A(1,1)
+!         b(2) = (b(2)-A(1,2)*b(1))/A(2,2)
+!         b(3) = (b(3)-A(1,3)*b(1)-A(2,3)*b(2))/A(3,3)
+!
+!!      Solve transpose(L)*x = y
+!         b(2) = b(2)-A(3,2)*b(3)
+!!         L = ipvt(2)
+!!         IF (L /= 2) THEN
+!!            TMP = B(2); B(2) = B(L); B(L) = TMP
+!!         END IF
+!         b(1) = b(1)-A(3,1)*b(3)-A(2,1)*b(2)
+!!         L = ipvt(1)
+!!         IF (L /= 1) THEN
+!!            TMP = B(1); B(1) = B(L); B(L) = TMP
+!!         END IF
+!   
+!      END SELECT
+!
+!END SUBROUTINE SOL3
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/tag2num.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/tag2num.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/tag2num.f90	(revision 2696)
@@ -0,0 +1,28 @@
+! ****************************************************************
+!                            
+! tag2num - convert equation tags to kpp reaction number
+!   Arguments :
+!      id        - string with the equation tag
+!
+! ****************************************************************
+
+ELEMENTAL INTEGER FUNCTION tag2num ( id )
+
+  USE KPP_ROOT_Monitor, ONLY: EQN_TAGS
+
+  CHARACTER(LEN=*), INTENT(IN) :: id
+  INTEGER i
+
+  tag2num = 0 ! mz_rs_20050115
+  DO i = 1, SIZE(EQN_TAGS)
+    IF (TRIM(EQN_TAGS(i)) == TRIM(id)) THEN
+      tag2num = i ! mz_rs_20050115
+      EXIT
+    ENDIF
+  END DO
+
+END FUNCTION tag2num
+
+! End of tag2num function
+! ****************************************************************
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.c	(revision 2696)
@@ -0,0 +1,70 @@
+/*
+#include <stdio.h>
+#include <stdlib.h>
+#include <math.h>
+*/
+KPP_REAL min( KPP_REAL x, KPP_REAL y )
+{
+  return ( x <= y ) ? x : y;
+}
+
+KPP_REAL max( KPP_REAL x, KPP_REAL y )
+{
+  return ( x >= y ) ? x : y;
+}
+
+static FILE *fpDat = 0;
+
+int InitSaveData()
+{
+  fpDat = fopen("KPP_ROOT.dat", "w");
+  if( fpDat == 0 ) {
+    printf("\n Can't create file : KPP_ROOT.dat");
+    exit(1);
+  }
+  return 0;
+}
+
+int SaveData()
+{
+int i;
+
+  fprintf( fpDat, "%6.1f ", TIME/3600.0 );
+  for( i = 0; i < NLOOKAT; i++ )
+    fprintf( fpDat, "%24.16e ", C[ LOOKAT[i] ]/CFACTOR );
+  fprintf( fpDat, "\n");
+  return 0;
+}
+
+int CloseSaveData()
+{
+  fclose( fpDat );
+  return 0;
+}
+
+int GenerateMatlab( char * prefix )
+{
+int i;
+FILE *fpMatlab;
+  
+  fpMatlab = fopen("KPP_ROOT.m", "w");
+  if( fpMatlab == 0 ) {
+    printf("\n Can't create file : KPP_ROOT.m");
+    exit(1);
+  }
+
+  fprintf(fpMatlab, "load KPP_ROOT.dat;\n");
+  fprintf(fpMatlab, "%sc = KPP_ROOT;\n", prefix);
+  fprintf(fpMatlab, "clear KPP_ROOT;\n");
+  fprintf(fpMatlab, "%st=%sc(:,1);\n", prefix, prefix);
+  fprintf(fpMatlab, "%sc(:,1)=[];\n", prefix);
+  
+  for( i = 0; i < NLOOKAT; i++ )
+    fprintf( fpMatlab, "%s%s = %sc(:,%d);\n", 
+            prefix, SPC_NAMES[LOOKAT[i]], 
+            prefix, i+1 );
+  
+  fclose( fpMatlab );
+  return 0;
+}
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.f	(revision 2696)
@@ -0,0 +1,102 @@
+C ****************************************************************
+C                            
+C InitSaveData - Opens the data file for writing
+C   Parameters :                                                  
+C
+C ****************************************************************
+
+      SUBROUTINE InitSaveData ()
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+
+      open(10, file='KPP_ROOT.dat')
+
+      RETURN
+      END
+
+C End of InitSaveData function
+C ****************************************************************
+
+C ****************************************************************
+C                            
+C SaveData - Write LOOKAT species in the data file 
+C   Parameters :                                                  
+C
+C ****************************************************************
+
+      SUBROUTINE SaveData ()
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+
+      INTEGER i
+
+      WRITE(10,999) (TIME-TSTART)/3600.D0,
+     *              (C(LOOKAT(i))/CFACTOR, i=1,NLOOKAT)
+999   FORMAT(E24.16,100(1X,E24.16))
+
+      RETURN
+      END
+
+C End of SaveData function
+C ****************************************************************
+
+C ****************************************************************
+C                            
+C CloseSaveData - Close the data file 
+C   Parameters :                                                  
+C
+C ****************************************************************
+
+      SUBROUTINE CloseSaveData ()
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+
+      CLOSE(10)
+
+      RETURN
+      END
+
+C End of CloseSaveData function
+C ****************************************************************
+
+C ****************************************************************
+C                            
+C GenerateMatlab - Generates MATLAB file to load the data file 
+C   Parameters : 
+C                It will have a character string to prefix each 
+C                species name with.                                                 
+C
+C ****************************************************************
+
+      SUBROUTINE GenerateMatlab ( PREFIX )
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+      
+      CHARACTER*8 PREFIX 
+      INTEGER i
+
+      open(20, file='KPP_ROOT.m')
+      write(20,*) 'load KPP_ROOT.dat;'
+      write(20,990) PREFIX
+990   FORMAT(A1,'c = KPP_ROOT;')
+      write(20,*) 'clear KPP_ROOT;'
+      write(20,991) PREFIX, PREFIX
+991   FORMAT(A1,'t=',A1,'c(:,1);')
+      write(20,992) PREFIX
+992   FORMAT(A1,'c(:,1)=[];')
+
+      do i=1,NLOOKAT
+        write(20,993) PREFIX, SPC_NAMES(LOOKAT(i)), PREFIX, i
+993     FORMAT(A1,A6,' = ',A1,'c(:,',I2,');')
+      end do
+      
+      CLOSE(20)
+
+      RETURN
+      END
+
+C End of GenerateMatlab function
+C ****************************************************************
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.f90	(revision 2696)
@@ -0,0 +1,101 @@
+! ****************************************************************
+!                            
+! InitSaveData - Opens the data file for writing
+!   Parameters :                                                  
+!
+! ****************************************************************
+
+      SUBROUTINE InitSaveData ()
+
+      USE KPP_ROOT_Parameters
+
+      open(10, file='KPP_ROOT.dat')
+
+      END SUBROUTINE InitSaveData
+
+! End of InitSaveData function
+! ****************************************************************
+
+! ****************************************************************
+!                            
+! SaveData - Write LOOKAT species in the data file 
+!   Parameters :                                                  
+!
+! ****************************************************************
+
+      SUBROUTINE SaveData ()
+
+      USE KPP_ROOT_Global
+      USE KPP_ROOT_Monitor
+
+      INTEGER i
+
+      WRITE(10,999) (TIME-TSTART)/3600.D0,  &
+                   (C(LOOKAT(i))/CFACTOR, i=1,NLOOKAT)
+999   FORMAT(E24.16,100(1X,E24.16))
+
+      END SUBROUTINE SaveData
+
+! End of SaveData function
+! ****************************************************************
+
+! ****************************************************************
+!                            
+! CloseSaveData - Close the data file 
+!   Parameters :                                                  
+!
+! ****************************************************************
+
+      SUBROUTINE CloseSaveData ()
+
+      USE KPP_ROOT_Parameters
+
+      CLOSE(10)
+
+      END SUBROUTINE CloseSaveData
+
+! End of CloseSaveData function
+! ****************************************************************
+
+! ****************************************************************
+!                            
+! GenerateMatlab - Generates MATLAB file to load the data file 
+!   Parameters : 
+!                It will have a character string to prefix each 
+!                species name with.                                                 
+!
+! ****************************************************************
+
+      SUBROUTINE GenerateMatlab ( PREFIX )
+
+      USE KPP_ROOT_Parameters
+      USE KPP_ROOT_Global
+      USE KPP_ROOT_Monitor
+
+      
+      CHARACTER(LEN=8) PREFIX 
+      INTEGER i
+
+      open(20, file='KPP_ROOT.m')
+      write(20,*) 'load KPP_ROOT.dat;'
+      write(20,990) PREFIX
+990   FORMAT(A1,'c = KPP_ROOT;')
+      write(20,*) 'clear KPP_ROOT;'
+      write(20,991) PREFIX, PREFIX
+991   FORMAT(A1,'t=',A1,'c(:,1);')
+      write(20,992) PREFIX
+992   FORMAT(A1,'c(:,1)=[];')
+
+      do i=1,NLOOKAT
+        write(20,993) PREFIX, SPC_NAMES(LOOKAT(i)), PREFIX, i
+993     FORMAT(A1,A6,' = ',A1,'c(:,',I2,');')
+      end do
+      
+      CLOSE(20)
+
+      END SUBROUTINE GenerateMatlab
+
+! End of GenerateMatlab function
+! ****************************************************************
+
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.m
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.m	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/util.m	(revision 2696)
@@ -0,0 +1,54 @@
+% ****************************************************************
+%                            
+% InitSaveData - Opens the data file for writing
+%
+% ****************************************************************
+
+function InitSaveData ()
+
+global KPP_ROOT_FID
+
+      KPP_ROOT_FID = fopen('KPP_ROOT.dat','w');
+
+return %  InitSaveData
+
+% End of InitSaveData function
+% ****************************************************************
+
+% ****************************************************************
+%                            
+% SaveData - Write LOOKAT species in the data file 
+%
+% ****************************************************************
+
+function SaveData ()
+
+global VAR FIX CFACTOR LOOKAT NLOOKAT KPP_ROOT_FID
+
+      C(1:KPP_NVAR) = VAR(1:KPP_NVAR);
+      C(KPP_NVAR+1:KPP_NSPEC) = FIX(1:KPP_NFIX);
+      
+      fprintf(KPP_ROOT_FID,'%12.5e,',C(LOOKAT(1:NLOOKAT)));
+
+return %  SaveData
+
+% End of SaveData function
+% ****************************************************************
+
+% ****************************************************************
+%                            
+% CloseSaveData - Close the data file 
+%
+% ****************************************************************
+
+function CloseSaveData ()
+global KPP_ROOT_FID
+
+      fclose( KPP_ROOT_FID );
+
+return %  CloseSaveData
+
+% End of CloseSaveData function
+% ****************************************************************
+
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/Makefile
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/Makefile	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/Makefile	(revision 2696)
@@ -0,0 +1,32 @@
+# -*- Makefile -*-
+# ----------------------------------------------
+export
+SHELL    = sh
+
+# ----------------------------------------------
+
+srcdir     = ./src
+bindir     = ./bin
+includedir = ./include
+PROG       = kpp4palm.exe
+
+# ----------------------------------------------
+
+all: $(PROG)
+
+$(PROG):
+	cd $(srcdir) ; \
+	$(MAKE)
+
+install: all
+	cp -pf $(srcdir)/$(PROG) $(bindir)/.
+
+clean:
+	rm -f $(srcdir)/*~
+	rm -f $(srcdir)/*.o
+	rm -f $(srcdir)/$(PROG)
+
+distclean: clean
+	rm -f $(bindir)/kp4.exe
+
+# ----------------------------------------------
